#ifndef FLOWSUBDIV3D_H
#define FLOWSUBDIV3D_H
#define m11Stride 1
#define m12Stride 1

#include <iostream>
#include "Mask3D.h"
#include "VectorField3D.h"

class FlowSubdiv3D
{
    public:
	FlowSubdiv3D();
	~FlowSubdiv3D();
	void setDiagonalMask(Mask3D*);
	void setOffDiagonalMask(Mask3D*);
	void subdivide(VectorField3D& coarse, VectorField3D& fine) const;

    protected:
	Mask3D *m11;
	Mask3D *m12;
};

inline FlowSubdiv3D::FlowSubdiv3D()
{
    m11 = m12 = NULL;
}

inline FlowSubdiv3D::~FlowSubdiv3D()
{
    m11 = m12 = NULL;
}

//Sets the masks
inline void FlowSubdiv3D::setDiagonalMask(Mask3D *aMask)
{
    m11 = aMask;
}

inline void FlowSubdiv3D::setOffDiagonalMask(Mask3D *aMask)
{
    m12 = aMask;
}

#endif
