//camera.h

#ifndef _CAMERA_
#define _CAMERA_

#include "main.h"



#define CT_FREE 0
#define CT_FLOAT 1

#define FLOAT_DISTANCE_MAX 150
#define FLOAT_DISTANCE_MIN 10

#define OT_NULL		0
#define OT_XY		1
#define OT_YZ		2
#define OT_XZ		3

#define PHI_MAX 0

class VIEWPORT;


class CAMERA
{
public:
	CAMERA();
	void update_camera();	//Update 'look' from position/angle

//	void init();
	void set_matrices();
	void set_matrices_ortho();
	void set_matrices_perspective();

	void set_overlay_matrices();
	void set_viewport(VIEWPORT *vp) {src_viewport = vp;}

	void set_XY();
	void set_YZ();
	void set_XZ();

	void zoom_out();
	void zoom_in();
	void grid_up();
	void grid_down();

	void mouse_move(POINT *cursor_pos, bool *click);

	XYZ at;
	XYZ look;
	XYZ up;
	float theta;
	float phi;

	float fov;
	float fov_init;
	int view_distance;

	float float_theta;
	float float_phi;
	float float_distance;

	float freemove_speed;
	void fix_angle();

	void draw_grid();

	int type;
protected:	//temp down here

	bool constrain_rotate;
	int projection;
	int drag_mod_x;
	int drag_mod_y;
	bool flip_drag;

	float orth_x;
	float orth_y;
	float zoom_speed;
	float drag_speed;
	float zoom_height;

	GRID2D grid;

	int ortho_type;

	VIEWPORT *src_viewport;
};



#endif

