//directory.cpp


#include "main.h"

extern LOGGER err_log;

//Checks from last element forward between two strings
// If either reaches end without a mismatch, return true
// Case insensitive
bool check_extension(char *str_i, char *ext_i)
{
	char *str;
	char *ext;
	int i,j;
	if (ext_i[0]==0) return true;
	bool r = false;

	str = (char*)calloc(strlen(str_i)+1,sizeof(char));
	ext = (char*)calloc(strlen(ext_i)+1,sizeof(char));

	strcpy(str,str_i);
	strcpy(ext,ext_i);

	strtolower(ext);
	strtolower(str);

	i = (int)strlen(str) - 1;
	j = (int)strlen(ext) - 1;

	while (true)
	{
		if (j<0)			{r = true;break;}
		if (i<0)			{r = false;break;}

		if (str[i]!=ext[j])	{r = false;break;}

		i--;
		j--;
	}

	free(str);
	free(ext);

	return r;
}

void strtolower(char *str)
{
	for (int i=0; i<(int)strlen(str); i++)
		str[i] = (char)tolower(str[i]);
}


#ifndef BUILD_WINDOWS

char *read_dir(char *dir_name, char *ext)
{
	char r[5120];
	r[0] = 0;

	err_log << "ERROR: Non-windows directory reading is not implemented yet!  Fools!" << endl;

	return r;
}

#endif






#ifdef BUILD_WINDOWS

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <string.h>

//IMPORTANT: The memory given here is potentially volatile;
// copy it elsewhere if it must persist.
char *read_dir(char *dir_name, char *ext)
{
	int i;
	char r[5120];
	r[0] = 0;
//	return r;

//	err_log << "Reading directory.." << endl;
	DIR *dp;

	struct dirent *dirp;
	struct stat buf;

	i = 0;
	dp = opendir(dir_name);
	while((dirp= readdir(dp))!=NULL)
	{
		stat(dirp->d_name,&buf);
//		if(S_ISREG(buf.st_mode))		//And this does what?  Thanks
//		printf("%s",dirp->d_name);

		if (check_extension(dirp->d_name,ext) && dirp->d_name[0]!=0)
		{
			if (i!=0)	strcat(r,"\n");
			strcat(r,dirp->d_name);
			i++;
		}

	}
	closedir(dp);

	//This will cause a warning, but it is ok -- the memory is copied
	// immediately after receiving it, so a later call will not conflict
	return r;
}


// Below this line is pretty much just ripped from dirent.c

DIR* opendir(const char* pDirName)
{
	struct stat sb;
	DIR*	pDir;
	char*	pEndDirName;
	int	nBufferLen;

	/* sanity checks */
	if (!pDirName) {
		errno = EINVAL;
		return NULL;
	}
	if (stat(pDirName, &sb) != 0) {
		errno = ENOENT;
		return NULL;
	}
	if ((sb.st_mode & S_IFMT) != S_IFDIR) {
		errno = ENOTDIR;
		return NULL;
	}

	/* allocate a DIR structure to return */
	pDir = (DIR *) malloc(sizeof (DIR));

	if (!pDir)
		return NULL;

	/* input directory name length */
	nBufferLen = (int)strlen(pDirName);

	/* copy input directory name to DIR buffer */
	strcpy(pDir->dir_pDirectoryName, pDirName);

	/* point to end of the copied directory name */
	pEndDirName = &pDir->dir_pDirectoryName[nBufferLen - 1];

	/* if directory name did not end in '/' or '\', add '/' */
	if ((*pEndDirName != '/') && (*pEndDirName != '\\')) {
		pEndDirName++;
		*pEndDirName = '/';
	}

	/* now append the wildcard character to the buffer */
	pEndDirName++;
	*pEndDirName = '*';
	pEndDirName++;
	*pEndDirName = '\0';

	/* other values defaulted */
	pDir->dir_nNumFiles = 0;
	pDir->dir_hDirHandle = INVALID_HANDLE_VALUE;	
	pDir->dir_ulCookie = __DIRENT_COOKIE;

	return pDir;
}

void closedir(DIR *pDir)
{
	/* got a valid pointer? */
	if (!pDir) {
		errno = EINVAL;
		return;
	}

	/* sanity check that this is a DIR pointer */
	if (pDir->dir_ulCookie != __DIRENT_COOKIE) {
		errno = EINVAL;
		return;
	}

	/* close the WINDOWS32 directory handle */
	if (pDir->dir_hDirHandle != INVALID_HANDLE_VALUE)
		FindClose(pDir->dir_hDirHandle);

	free(pDir);

	return;
}


struct dirent *readdir(DIR* pDir)
{
	WIN32_FIND_DATA wfdFindData;

	if (!pDir) {
		errno = EINVAL;
		return NULL;
	}

	/* sanity check that this is a DIR pointer */
	if (pDir->dir_ulCookie != __DIRENT_COOKIE) {
		errno = EINVAL;
		return NULL;
	}

	if (pDir->dir_nNumFiles == 0) {
		pDir->dir_hDirHandle = FindFirstFile(pDir->dir_pDirectoryName, &wfdFindData);
		if (pDir->dir_hDirHandle == INVALID_HANDLE_VALUE)
			return NULL;
	} else if (!FindNextFile(pDir->dir_hDirHandle, &wfdFindData))
			return NULL;

	/* bump count for next call to readdir() or telldir() */
	pDir->dir_nNumFiles++;

	/* fill in struct dirent values */
	pDir->dir_sdReturn.d_ino = -1;
	strcpy(pDir->dir_sdReturn.d_name, wfdFindData.cFileName);

	return &pDir->dir_sdReturn;
}

void rewinddir(DIR* pDir)
{
	if (!pDir) {
		errno = EINVAL;
		return;
	}

	/* sanity check that this is a DIR pointer */
	if (pDir->dir_ulCookie != __DIRENT_COOKIE) {
		errno = EINVAL;
		return;
	}

	/* close the WINDOWS32 directory handle */
	if (pDir->dir_hDirHandle != INVALID_HANDLE_VALUE)
		if (!FindClose(pDir->dir_hDirHandle))
			errno = EBADF;

	/* reset members which control readdir() */
	pDir->dir_hDirHandle = INVALID_HANDLE_VALUE;
	pDir->dir_nNumFiles = 0;

	return;
}

int telldir(DIR* pDir)
{
	if (!pDir) {
		errno = EINVAL;
		return -1;
	}

	/* sanity check that this is a DIR pointer */
	if (pDir->dir_ulCookie != __DIRENT_COOKIE) {
		errno = EINVAL;
		return -1;
	}

	/* return number of times readdir() called */
	return pDir->dir_nNumFiles;
}

void seekdir(DIR* pDir, long nPosition)
{
	if (!pDir)
		return;

	/* sanity check that this is a DIR pointer */
	if (pDir->dir_ulCookie != __DIRENT_COOKIE)
		return;

	/* go back to beginning of directory */
	rewinddir(pDir);

	/* loop until we have found position we care about */
	for (--nPosition; nPosition && readdir(pDir); nPosition--);

	/* flag invalid nPosition value */
	if (nPosition)
		errno = EINVAL;

	return;
}



#endif

