//display.h

#ifndef _DISPLAY_
#define _DISPLAY_

#include "main.h"

#define D_MAX_GUI			16
// ** UPDATE THE DEFAULT CREATION THING..

#define GL_CLAMP_TO_EDGE 0x812F

class FONTS;
class DISPLAY;

struct TEXTURE_DATA
{
	TEXTURE_DATA() {active=false;}
	int active;
	int width;
	int height;
};

struct TEXTURES
{

	int gui[D_MAX_GUI];

	//etc

	void set_default_texture();
	int def;	//default texture
};

class DISPLAY
{
public:
	DISPLAY();
	~DISPLAY();
	void destroy();

	int init();

	void enables();
	void init_textures();
	void set_transparent(int tex_num, float x, float y, float z, int dimx, int dimy);
	void set_screen(int x, int y);
	void set_world(float fx, float fy);

	SDL_Surface *load_bmp(const char *Filename);

	int init_texture(const char *filename);
	int init_texture(const char *filename, float x, float y, float z);
	int init_texture(const char *filename, GLuint wrap_param, GLuint mag_filter, GLuint internal, bool use_mipmaps);
	int init_texture(const char *filename, GLuint wrap_param, GLuint mag_filter, GLuint internal, bool use_mipmaps, float x, float y, float z);
	int init_texture(const char *filename, GLuint wrap_param);

	bool full_screen;

	void screen_shot();

	int screen_x;
	int screen_y;
	int screen_half_x;
	int screen_half_y;
	int screen_bits;
	float world_x;
	float world_y;

	float pworld_x;
	float pworld_y;

	float background_color[4];

	TEXTURES *textures;
	OVERLAY *overlay;
	FONTS *fonts;

	VIEWPORTS viewports;

	TEXTURE_DATA *texture_data;

	EXTRA *extra;

	bool initialized;

	bool is_fullscreen() {return fullscreen;}

	GLdouble modelMatrix[16];
	GLdouble projMatrix[16];
	GLint viewport[4];


protected:

	bool fullscreen;
	SDL_PixelFormat default_format;

	void get_last_screen_shot();
	int last_screen_shot;


};



#endif

