//font.h


#ifndef _FONT_
#define _FONT_

#include "main.h"

#define FF_SIMPLE_SMALL		0
#define FF_DOOM_SMALL		1
#define FF_DOOM_SMALL_WHITE	2
#define FF_TIMES_SMALL		3

#define FF_DEFAULT FF_SIMPLE_SMALL

#define MAX_CHARACTERS	128
#define MAX_FONTS		8

struct FONT_CHARACTER
{
	float u0, u1;
	float v0, v1;
	char c;
	int w;
	int h;
};

class FONT
{
public:
	FONT();
	~FONT();

	void set_face(char *filename, int new_drop);
	void set_face(char *filename);
	void set_face(char *filename, float dr, float dg, float db);


	void draw(char *text, int x, int y);

	
	void set_drop(int new_drop);

	FONT_CHARACTER c[MAX_CHARACTERS];
	int tex;
	int spacing_x;
	int spacing_y;
	int max_height;
	int max_width;
	int drop;

	//** Dropping value for entire font.  This to compensate
	// dropped characters, like the 'g' in TIMES
protected:

};

class FONTS
{
public:
	FONTS();

	void build_fonts();

	void draw(int use_face, char *text, int x, int y, float r, float g, float b, float a);
	void draw(int use_face, char *text, int x, int y);
	void draw(char *text, int x, int y);
	void draw(int use_face, char *text, float x, float y, float z);

	void set_color(float r, float g, float b, float a);

	int get_spacing_x(int font);
	int get_spacing_y(int font);
	int get_width(int font, char this_c);
	int get_max_height(int font);
	int get_max_width(int font);

protected:
	FONT face[MAX_FONTS];
	IMG_RGBAf color;
};






#endif





