//frame.h

#ifndef _FRAME_
#define _FRAME_

#include "main.h"


#define RANDOM_SEED			19
#define MIN_TIME_STEP		.01f
#define MAX_MODELS	16

//#define MAX_ERRORS				16
//#define MAX_ERROR_STRING		32

class FRAME;

struct EXTENTS
{
	EXTENTS() {x0=0;y0=0;z0=0;x1=0;y1=0;z1=0;}
	void set(float nx0, float ny0, float nz0, float nx1, float ny1, float nz1)
	{x0=nx0;y0=ny0;z0=nz0; x1=nx1;y1=ny1;z1=nz1;}
	float x0,y0,z0;
	float x1,y1,z1;
};

class FRAME
{
public:
	FRAME();
	~FRAME();

	void destroy();

	int init();
//	void init_error(char *str, int val);
//	void init_errors();
//	void add_error();
	void fail(const char *fmt, ...);

	void quit(int code);
	void quit(char *reason, int code);
	void finish();

	void do_main_loop();
	void redraw();

	void wait(float target);

	float abs(float a);

	double absolute_longest_edge;
	float bin_width;
	void init_bins();

	void mark();
	void mark(char *what);
	void markf(char *title, float value);
	void marki(char *title, int value);
	void marks(char *title, char *value);

	void gl_errors();
	void warning(const char *fmt, ...);
	void error(const char *fmt, ...);
//	void warning(char *reason);
//	void error(char *reason);

	void shout(const char *fmt, ...);

	void pvector(char *label, float v[3]);
	void pvector(char *label, double v[3]);

	//Change these to pointers?  Sheesh, this is getting ugly

	ENGINE engine;
	DISPLAY display;
	CONTROL *control;
	CAMERA *camera;
	MAGIC magic;
	CONFIG config;
	CONSOLE console;

	EXTENTS extents;

	MESSAGES *messages;

	BIN_LIST *bins;
	long cache_misses;
	long cache_hits;

	MODEL model[MAX_MODELS];
	int current_model;
	void inc_model();



//	VERTEX_ARRAY vertex_array;

	VECTOR_FIELD *vector_field;

	PHOTON_LIST photon_list;

	SDL_Surface *screen;

	KEY_NAMES key_names;

	IBFV ibfv;

	void delete_list(int *display_list);
	void create_list(int *display_list);

	bool initialized;
	bool done;				// Bool Variable To Exit Loop


	bool add_model(char *file, char *name);
	int num_models;

	bool add_field(char *file);

	void bin_down(bool new_lists);

//	char error_string[MAX_ERRORS][MAX_ERROR_STRING];
//	int error_value[MAX_ERRORS];
//	int error_index;

protected:


};

#endif

