//graphic_box.h

#ifndef _GRAPHIC_BOX_
#define _GRAPHIC_BOX_

#include "main.h"

#define GBT_CLEAR		0
#define GBT_SOLID		1
#define GBT_TEXTURED	2

class GRAPHIC_BOX
{
public:
	GRAPHIC_BOX();

	void set_tex(int new_tex, int nw);
	void set_dims(int new_width, int new_height);
	void set_pos(int nx, int ny);
//	void set_pos(int nx, int ny, int new_width, int new_height);
	void set_height(int new_height);

	void set_type(int new_type);
	void set_type(int new_type, int new_tex_background);
	void set_textured_background_uv();

	void set_color(float r, float g, float b, float a);
	void set_color_background(float r, float g, float b, float a);
	void set_passive_alpha(bool new_passive_alpha);

	int get_height();

	void draw();

protected:

	int type;

	int x;
	int y;
	int width;
	int height;

	int w;
	int tex;
	int tex_background;

	bool passive_alpha;

	IMG_RGBAf color;
	IMG_RGBAf color_background;

	float u[9][2];
	float v[9][2];

	int vx[9][2];
	int vy[9][2];


};









#endif




