//ibfv.h
//
// Impromptu header for simple containment class for IBFV implementation
// (see ibfv.cpp for credits)

#include "main.h"


#define MAX_IBFV_FACES 3

struct IBFV_FACE
{
	float ***slice;	//mini slice of vector field
//	float slice[NMESH][NMESH][2];	//mini slice of vector field
	int iframe;
};

class IBFV
{
public:
	IBFV();
	~IBFV();

	void init(int new_num_faces);

	void generate_all();
	void draw_all();

	void set_faces();

	void dye_test();

protected:

	void generate(int g);
	void draw(int g);

	void gl_start();
	void gl_stop();

	void make_patterns();
	void getDP(int i, int j, float *px, float *py, int g);

	int iframe;
	int Npat;
	int alpha;
	float sa;
	float tmax;
	float dmax;
	GLuint list_start;

	double ox, oy, oz;
	double wx, wy, wz;

	float dx0, dy0, dz0;
	float dx1, dy1, dz1;
	float dx2, dy2, dz2;

	int num_faces;
	IBFV_FACE face[MAX_IBFV_FACES];

	double timer_max;
	double timer;

	//Just one for now, but later we'll need one for each frame!
	GLuint *tex;

	int dye;
};
