//key_names.cpp

#include "main.h"

extern FRAME frame;
extern LOGGER err_log;


void KEY_NAMES::build(char **key)
{
	int i;
	for (i=0; i<MAX_KEYS; i++) key[i] = NULL;

	CAS(SDLK_BACKSPACE,"[Backspace]");
	CAS(SDLK_TAB,"[Tab]");
	CAS(SDLK_RETURN,"[Enter]");
	CAS(SDLK_ESCAPE,"[Escape]");
	CAS(SDLK_SPACE,"[Space]");
	CAS(SDLK_PAUSE,"[Pause]");

	CAS('`',"[~]");
	CAS('1',"[1]");
	CAS('2',"[2]");
	CAS('3',"[3]");
	CAS('4',"[4]");
	CAS('5',"[5]");
	CAS('6',"[6]");
	CAS('7',"[7]");
	CAS('8',"[8]");
	CAS('9',"[9]");
	CAS('0',"[0]");
	CAS('-',"[-]");
	CAS('=',"[+]");
	CAS('[',"[ [ ]");
	CAS(']',"[ ] ]");
	CAS(92,"[\\]");
	CAS(';',"[;]");
	CAS(39,"[\']");
	CAS(',',"[,]");
	CAS('.',"[.]");
	CAS(47,"[/]");
	CAS('a',"[A]");
	CAS('b',"[B]");
	CAS('c',"[C]");
	CAS('d',"[D]");
	CAS('e',"[E]");
	CAS('f',"[F]");
	CAS('g',"[G]");
	CAS('h',"[H]");
	CAS('i',"[I]");
	CAS('j',"[J]");
	CAS('k',"[K]");
	CAS('l',"[L]");
	CAS('m',"[M]");
	CAS('n',"[N]");
	CAS('o',"[O]");
	CAS('p',"[P]");
	CAS('q',"[Q]");
	CAS('r',"[R]");
	CAS('s',"[S]");
	CAS('t',"[T]");
	CAS('u',"[U]");
	CAS('v',"[V]");
	CAS('w',"[W]");
	CAS('x',"[X]");
	CAS('y',"[Y]");
	CAS('z',"[Z]");

	CAS(SDLK_KP0,"Keypad 0");
	CAS(SDLK_KP1,"Keypad 1");
	CAS(SDLK_KP2,"Keypad 2");
	CAS(SDLK_KP3,"Keypad 3");
	CAS(SDLK_KP4,"Keypad 4");
	CAS(SDLK_KP5,"Keypad 5");
	CAS(SDLK_KP6,"Keypad 6");
	CAS(SDLK_KP7,"Keypad 7");
	CAS(SDLK_KP8,"Keypad 8");
	CAS(SDLK_KP9,"Keypad 9");
	CAS(SDLK_KP_PERIOD,"Keypad .");
	CAS(SDLK_KP_DIVIDE,"Keypad /");
	CAS(SDLK_KP_MULTIPLY,"Keypad *");
	CAS(SDLK_KP_MINUS,"Keypad -");
	CAS(SDLK_KP_PLUS,"Keypad +");
	CAS(SDLK_KP_ENTER,"Keypad [Enter]");
	CAS(SDLK_KP_EQUALS,"Keypad =");

	CAS(SDLK_UP,"[Arrow Up]");
	CAS(SDLK_DOWN,"[Arrow Down]");
	CAS(SDLK_LEFT,"[Arrow Left]");
	CAS(SDLK_RIGHT,"[Arrow Right]");
	CAS(SDLK_INSERT,"[Insert]");
	CAS(SDLK_HOME,"[Home]");
	CAS(SDLK_END,"[End]");
	CAS(SDLK_PAGEUP,"[Page Up]");
	CAS(SDLK_PAGEDOWN,"[Page Down]");

	CAS(SDLK_F1,"[F1]");
	CAS(SDLK_F2,"[F2]");
	CAS(SDLK_F3,"[F3]");
	CAS(SDLK_F4,"[F4]");
	CAS(SDLK_F5,"[F5]");
	CAS(SDLK_F6,"[F6]");
	CAS(SDLK_F7,"[F7]");
	CAS(SDLK_F8,"[F8]");
	CAS(SDLK_F9,"[F9]");
	CAS(SDLK_F10,"[F10]");
	CAS(SDLK_F11,"[F11]");
	CAS(SDLK_F12,"[F12]");
	CAS(SDLK_F13,"[F13]");
	CAS(SDLK_F14,"[F14]");
	CAS(SDLK_F15,"[F15]");

	CAS(SDLK_NUMLOCK,"[Num Lock]");
	CAS(SDLK_CAPSLOCK,"[Caps Lock]");
	CAS(SDLK_SCROLLOCK,"[Scroll Lock]");
	CAS(SDLK_RSHIFT,"[Right Shift]");
	CAS(SDLK_LSHIFT,"[Left Shift]");
	CAS(SDLK_RCTRL,"[Right Control]");
	CAS(SDLK_LCTRL,"[Left Control]");
	CAS(SDLK_RALT,"[Right Alt]");
	CAS(SDLK_LALT,"[Left Alt]");
	CAS(SDLK_RMETA,"[Right Meta]");
	CAS(SDLK_LMETA,"[Left Meta]");
	CAS(SDLK_LSUPER,"[Left Super]");
	CAS(SDLK_RSUPER,"[Right Super]");

	CAS(SDLK_HELP,"[Help]");
	CAS(SDLK_PRINT,"[Print]");
	CAS(SDLK_SYSREQ,"[Sys Req]");
	CAS(SDLK_BREAK,"[Break]");
	CAS(SDLK_MENU,"[Menu]");
	CAS(SDLK_POWER,"[Power]");
	CAS(SDLK_EURO,"[Euro]");
	CAS(SDLK_UNDO,"[Undo]");

	CAS(MOUSE_LEFT,"[Mouse Left Button]");
	CAS(MOUSE_MIDDLE,"[Mouse Middle Button]");
	CAS(MOUSE_RIGHT,"[Mouse Right Button]");
	CAS(MOUSE_WHEEL_UP,"[Mouse Wheel Up]");
	CAS(MOUSE_WHEEL_DOWN,"[Mouse Wheel Down]");

//	CAS(,"");


	/*
		CAS(33,"!");
	CAS(34,"\"");
	CAS(35,"#");
	CAS(36,"$");
	CAS(37,"%");
	CAS(38,"&");
	CAS(39,"\'");
	CAS(40,"(");
	CAS(41,")");
	CAS(42,"*");
	CAS(43,"= / +");
	CAS(44,",");
	CAS(45,"");
	CAS(46,"");
	CAS(47,"");
	CAS(48,"");
	CAS(49,"");
	CAS(50,"");
*/

	for (i=0; i<MAX_KEYS; i++)
	{
		if (key[i]==NULL)
		{
			key[i] = (char*)calloc(1,sizeof(char));
			sprintf(key[i],"");
		}
	}
}

#define CAS(i,str) \
			if (key[i]!=NULL) free(key[i]); \
			key[i] = (char*)calloc(strlen(str)+1,sizeof(char)); \
			sprintf(key[i],"%s",str);

void KEY_NAMES::destroy(char **key)
{
	for (int i=0; i<MAX_KEYS; i++)
	{
		if (key[i]!=NULL)
		{
			free(key[i]);
//			key[i] = (char*)calloc(1,sizeof(char));
//			sprintf(key[i],"");
		}
	}
}


