//main.cpp

#include "main.h"

//Basic objects
FRAME frame;
LOGGER err_log;
LOGGER errors;



//Integral Functions
//void do_main_loop();	//Main loop
void redraw();			//Redraw screen (used to be display() )

//Helper functions
double rnd();
double rnd(float range);



int sub_test()
{
/*******

Fine and course seem to be defined too small?   Works OK and netbsd, as the memory outside the arrays
is initialized to all zero.  But on windows, it is initialized to all ones, so we get some crazy
behavior.  Increasing the size allocated (and initialized to 0.0) fixes it.

*******/

	int i;
    float *fine = new float[mem_size(1,32)];
    float *coarse = new float[mem_size(0,32)];
    
    *(coarse) = 3;
    *(coarse+1) = 3;
    *(coarse+2) = 3;
    
    for (i = 0; i < (mem_size(0,32) - 3)/3; i+=3)
    {
        *(coarse + 3 + i) = 0.0;
        *(coarse + 4 + i) = 0.0;
        *(coarse + 5 + i) = 0.0;
    }
    *(coarse + 3) = 1;

    for (i = 0; i < mem_size(0,3)/3 + 2; i++)
        printf("%f\n", *(coarse + i));

    printf("==================\n");
    
    subdivide(1, 15, coarse, fine);
    for (i = 0; i < mem_size(1,3); i++)
	{
//        printf("%f\n", fine[i]);
        printf("%f\n", *(fine + i));
	}
    
    delete fine;
    delete coarse;

    return 0;
}


int main(int argc, char **argv)
{
//	sub_test();
//	return 0;

	if (frame.init()<=0)
		frame.fail("Error initializing frame.");

	frame.do_main_loop();
//	frame.quit(1);

	frame.destroy();

	return (0);
}


double rnd()
{
	return ((double)rand()/(double)RAND_MAX);
}

double rnd(float range)
{
	return (rnd()*range)-range/2;
}


bool substrcis(char *search, char *from, char *exclude)
{
	int i,j;
	int cs = (int)strlen(search);
	int cf = (int)strlen(from);
	int ce = (int)strlen(exclude);
	bool found;
	bool efound;

	for (i=0;i<cf;i++)
	{
		efound=true;
		for (j=0;j<ce;j++)
			if (from[i+j]!=exclude[j]) efound=false;
		if (efound) return false;

		found = true;
		for (j=0;j<cs;j++)
			if (from[i+j]!=search[j] &&
				from[i+j]+32!=search[j] &&
				from[i+j]-32!=search[j])
			{found=false;break;}

		if (found) return true;
	}
	return false;
}


