//main.h
//
//Random includes and such.  Enjoy.

#ifndef _MAIN_H_
#define _MAIN_H_

#define BUILD_WINDOWS

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <fstream>
#include <iostream>
#include <fcntl.h>      /* Needed only for _O_RDWR definition */


#include <sdl.h>
#include <SDL_opengl.h>

#include <gl\glu.h>
#include <gl\glut.h>
//#include <gl\glaux.h>


#include <math.h>
using namespace std;

#pragma comment(lib, "opengl32.lib")
#pragma comment(lib, "glu32.lib")
#pragma comment(lib, "glaux.lib")
#pragma comment(lib, "glut32.lib")
#pragma comment(lib, "sdl.lib")
#pragma comment(lib, "sdlmain.lib")

const double pi=3.141592654;

const double deg45 = 0.785398164;
const double deg90 = 1.570796327;
const double deg135 = 2.356194491;
const double deg180 = 3.141592654;
const double deg225 = 3.926990818;
const double deg270 = 4.71238898;
const double deg315 = 5.497787145;
const double deg360 = 6.283185307;

const double deg2rad = pi/180;
const double rad2deg = 180/pi;

#define ENABLE_LOGGING 1

#define MAX_TEXTURES 2048

#include "directory.h"

//My own stuff
class FRAME;


#include "subdivide.h"

//Base
//#include <ply.h>
#include "extra.h"
#include "residue.h"
#include "key_names.h"
#include "intersection.h"
#include "list.h"
#include "trail.h"
#include "rply.h"
#include "model.h"
#include "bin.h"
#include "phys_obj.h"
#include "photon.h"
#include "vectors.h"
#include "grid.h"
#include "define.h"
#include "dynarray.h"
#include "errlog.h"
#include "img.h"
#include "vector_field.h"


//Object
#include "message.h"
#include "magic_begin.h"
#include "camera.h"
#include "viewport.h"
#include "graphic_box.h"
#include "overlay.h"
#include "text_box.h"
#include "console.h"
#include "ibfv.h"

//Major
#include "control.h"
#include "engine.h"
#include "display.h"
#include "font.h"
#include "config.h"

//Frame
#include "frame.h"



#endif

