//message.cpp

#include "main.h"

extern FRAME frame;
extern LOGGER err_log;

MESSAGES::MESSAGES(int new_font)
{
	font = new_font;
	height = frame.display.fonts->get_max_height(font) + frame.display.fonts->get_spacing_y(font);
	index = 0;
}

MESSAGE::MESSAGE()
{
	ttl = 0;
	active = false;
	for (int i=0; i<MAX_MESSAGE_LENGTH; i++)
		text[i] = 0;
}

void MESSAGES::add(const char *fmt, ...)
{
	char message[1024];
	va_list ap;
	for (int i=0; i<1024; i++) message[i]=0;
	if (fmt != NULL)
	{
		va_start(ap, fmt);
		vsprintf(message, fmt, ap);
		va_end(ap);
	}
	message[MAX_MESSAGE_LENGTH-1] = 0;

	err_log << "MESSAGE: " << message << endl;

	sprintf(list[index].text,message);
	list[index].active = true;
	list[index].ttl = MESSAGE_TTL;


	index++;
	while (index>=MAX_MESSAGES) index -= MAX_MESSAGES;


}

void MESSAGES::step()
{
	MESSAGE *tmp = &list[0];
	float f = frame.engine.get_super_time_difference();

	for (int i=0; i<MAX_MESSAGES; i++)
	{
		if (tmp->active)
		{
			tmp->ttl -= f;

			if (tmp->ttl <= 0)
			{
				tmp->ttl = 0;
				tmp->active = false;
			}
		}

		tmp++;
	}
}

void MESSAGES::draw()
{
	int I;
	int y = frame.display.screen_y;
	int n = 1;
	for (int i=0; i<MAX_MESSAGES; i++)
	{
		I = index-i-1;
		while (I<0) I += MAX_MESSAGES;

//		I = i;

		if (list[I].active)
		{
			frame.display.fonts->draw(font, list[I].text,0,y - n*height);
			n++;
		}
	}
}
