//overlay.cpp

#include "main.h"

extern FRAME frame;
extern double rnd();
extern LOGGER err_log;

OVERLAY::OVERLAY()
{
}
void OVERLAY::init()
{
}
OVERLAY::~OVERLAY()
{
}

void OVERLAY::draw_global()
{
//	return;

	glDisable(GL_DEPTH_TEST);
	frame.camera->set_overlay_matrices();
	glViewport(0,0,frame.display.screen_x,frame.display.screen_y);


	if (!frame.config.get_bool(VAR_SINGLE_VIEW))
	{
		frame.magic.try_end();
		glDisable(GL_TEXTURE_2D);
		glColor4f(.85f,.63f,.1f,1);
		glBegin(GL_LINES);
			glVertex2f(0,frame.display.screen_half_y);	glVertex2f(frame.display.screen_x,frame.display.screen_half_y);
			glVertex2f(frame.display.screen_half_x,0);	glVertex2f(frame.display.screen_half_x,frame.display.screen_y);
		glEnd();
		glEnable(GL_TEXTURE_2D);
	}


	/*
	frame.magic.try_end();
	glDisable(GL_TEXTURE_2D);
	glColor4f(1,1,1,1);
	glBegin(GL_POLYGON);
		glVertex3f(0,0,0);
		glVertex3f(0,100,0);
		glVertex3f(100,100,0);
		glVertex3f(100,0,0);
	glEnd();
	glEnable(GL_TEXTURE_2D);

	frame.display.fonts->draw(FF_DOOM_SMALL, "HI YOU JERK", 0, 0, 1,1,1,1);
	*/


	char fps[512];
	if (frame.config.get_bool(VAR_DRAW_FPS))
	{
		sprintf(fps,"FPS: %f\n",frame.engine.get_fps());
		frame.display.fonts->draw(FF_DOOM_SMALL, fps,frame.display.screen_x - 80,frame.display.screen_y-10, 1,1,1,1);
	}

	if (frame.config.get_bool(VAR_SHOW_KEYS))
	{
		glColor4f(0,1,0,1);
		frame.control->show_bindings();
	}
	if (frame.config.get_bool(VAR_SHOW_VARS))
	{
		glColor4f(1,1,0,1);
		frame.config.show_vars();
	}

	if (frame.config.get_bool(VAR_DRAW_MESSAGES))
	{
		glColor4f(1,.5f,0,1);
		frame.messages->step();
		frame.messages->draw();
	}

	frame.console.step();
	frame.console.draw();

	glColor4f(0,1,0,1);
	announce.draw();

	frame.magic.try_end();
	glEnable(GL_DEPTH_TEST);
}

void OVERLAY::draw()
{
	glPushMatrix();

	glDisable(GL_DEPTH_TEST);
	frame.camera->set_overlay_matrices();

	glColor4f(1,1,1,1);


/*
	bool q0 = frame.current_human->quadrant0;
	bool q1 = frame.current_human->quadrant1;
	bool q2 = frame.current_human->quadrant2;
	bool q3 = frame.current_human->quadrant3;
	bool r,l,b,t;
	r=l=b=t=false;

	int sx = frame.display.screen_x - 1;
	int sy = frame.display.screen_y - 1;

	if ((q0&&!q1) || (q2&&!q3))	r=true;
	if ((!q0&&q1) || (!q2&&q3))	l=true;
	if ((q0&&!q2) || (q1&&!q2))	b=true;
	if ((!q0&&q2) || (!q1&&q3))	t=true;

	frame.magic.try_end();
	glDisable(GL_TEXTURE_2D);
	glColor4f(0,.5,0,1);
	glLineWidth(1);
	if (r) {glBegin(GL_LINE_STRIP); glVertex2f(sx,0);	glVertex2f(sx,sy);	glEnd();}
	if (l) {glBegin(GL_LINE_STRIP); glVertex2f(0,0);	glVertex2f(0,sy);	glEnd();}
	if (b) {glBegin(GL_LINE_STRIP); glVertex2f(0,0);	glVertex2f(sx,0);	glEnd();}
	if (t) {glBegin(GL_LINE_STRIP); glVertex2f(0,sy);	glVertex2f(sx,sy);	glEnd();}

	glEnable(GL_TEXTURE_2D);
*/


	glEnable(GL_DEPTH_TEST);

	glPopMatrix();
}

ANNOUNCE::ANNOUNCE()
{
	text[0] = 0;
	age = 0;
}
void ANNOUNCE::set(const char *fmt, ...)
{
	char message[1024];
	va_list ap;
	
	for (int i=0; i<1024; i++) message[i]=0;

	if (fmt != NULL)
	{
		va_start(ap, fmt);
		vsprintf(message, fmt, ap);
		va_end(ap);
	}

	strcpy(text, message);
	age = ANNOUNCE_TTL;
}
void ANNOUNCE::draw()
{
	if (age <= 0)
		return;

	frame.display.fonts->draw(FF_DOOM_SMALL, text,0,0, 1,1,1,1);
	age -= frame.engine.get_time_difference();
}

void OVERLAY::set_wait_reason(char *reason)
{
	sprintf(prog_msg,"%s ",reason);
}

void OVERLAY::show_calculating(char *reason)
{
	set_wait_reason(reason);
	show_calculating();
}
void OVERLAY::show_calculating()
{
	frame.magic.try_end();
	glPushMatrix();
//	frame.camera->set_overlay_matrices();

	int x = frame.display.screen_half_x-25;
	int y = frame.display.screen_half_y;
	int h = 10;
	int w = 50;
	int p = 20;
	int X = frame.display.screen_x;

	y = p;

	glDisable(GL_DEPTH_TEST);
	glDisable(GL_TEXTURE_2D);

	glColor4f(1,.5f,0,1);
	glBegin(GL_POLYGON);
	glVertex2f(0,	y-p);
	glVertex2f(0,	y+h+p);
	glVertex2f(X,	y+h+p);
	glVertex2f(X,	y-p);
	glEnd();

	glEnable(GL_TEXTURE_2D);
	frame.display.fonts->draw(FF_TIMES_SMALL, prog_msg,x,y, 1,1,1,1);
	frame.magic.try_end();

	glEnable(GL_DEPTH_TEST);


	glPopMatrix();
	SDL_GL_SwapBuffers();

}


void OVERLAY::post_progress(float progress)
{
	if (progress>1) progress = 1;
	if (progress<0) progress = 0;

	frame.magic.try_end();
	glPushMatrix();
//	frame.camera->set_overlay_matrices();

	int x = frame.display.screen_half_x-25;
	int y = frame.display.screen_half_y;
	int h = 10;
	int w = 50;
	int p = 20;
	int X = frame.display.screen_x;

	y = p;

	int d = progress * X;

	glDisable(GL_DEPTH_TEST);
	glDisable(GL_TEXTURE_2D);

	glColor4f(0,.5f,0,1);
	glBegin(GL_QUADS);
	glVertex2f(0,	y-p);
	glVertex2f(0,	y+h+p);
	glVertex2f(d,	y+h+p);
	glVertex2f(d,	y-p);

	glColor4f(1,.5f,0,1);
	glVertex2f(d,	y-p);
	glVertex2f(d,	y+h+p);
	glVertex2f(X,	y+h+p);
	glVertex2f(X,	y-p);
	glEnd();

	glEnable(GL_TEXTURE_2D);

	char text[128];
	sprintf(text,"%s [ %.2f%% ]",prog_msg,(progress * 100.0f));
	frame.display.fonts->draw(FF_TIMES_SMALL, text,x,y, 1,1,1,1);
	frame.magic.try_end();

	glEnable(GL_DEPTH_TEST);


	glPopMatrix();
	SDL_GL_SwapBuffers();

}


