//photon.h

#ifndef _PHOTON_
#define _PHOTON_

#include "main.h"

#define TERMINATE_CHANCE	.005f

//How to spread the photon simulation particles
#define ST_RANDOM		0	//Randomly placed within extents
#define ST_GRID			1	//Strictly grid-placed within extents
#define ST_JITTER		2	//Same as grid, but with jitter at each grid point


class PHOTON : public PHYS_OBJ
{
public:
	PHOTON();

	void zero_vars();
	void check_vars();

	void draw();
	void step();

	void activate();

protected:

	float color[4];
	long steps;

	RESIDUE residue;
};


class PHOTON_LIST : public LIST<PHOTON>
{
public:
	void add(double nx, double ny, double nz);
	PHOTON *add(double nx, double ny, double nz, double vx, double vy, double vz);

	void run_simulation();
	void add_and_run(double nx, double ny, double nz, double vx, double vy, double vz);

	void zero_vars();

protected:

	//Used to ensure just one cast of subdiv-only photons
	bool first_subdiv;
};





#endif


