//phys_obj.h

#ifndef _PHYS_OBJ_
#define _PHYS_OBJ_

#include "main.h"

struct POLY;
struct CLOSEST_COLLISION;

#define GRAVITY							.00001f
#define MIN_COLLISION_DAMAGE_SPEED		.001
#define MIN_PARTICLE_SPEED				.0001

class BIN;

class PHYS_OBJ
{
public:
	PHYS_OBJ();

	void zero_vars();

	void check_vars();

//	virtual void draw()=0;
//	virtual void step()=0;


	bool is_active() {return active;}

	void set_pos(double nx, double ny, double nz)
	{ pos[0] = nx; pos[1] = ny; pos[2] = nz; }

	double get_pos(int i) {return pos[i];}

	void add_force(double nx, double ny, double nz);
	void add_force(double n[3]);

	void collide(int dim, double limit);
	void collide_poly();

	void convert_force();
	bool move();
	void move_from_velocity(float f);

	void kill();
	void activate();

	bool active;

	double v;

	double pos[3];
	double vel[3];
	double acc[3];
	double force[3];
	double mass;

	bool extent_bound;

	double gravity;
	double elasticity;
	double vf_bias;

	bool conserve_momentum;

	void mark() {marked = true;}
	bool marked;

	bool just_collided;
	double t;

	double birth_time;

	TRAIL_LIST trail;

	int collision_count;
	int collision_max;

	BIN *bin_src;

	CLOSEST_COLLISION last_poly_collision;

	float rad_limit;

	//It might be better to view phys_obj as a public struct, as it's only accessed
	// within other member functions, and quite often I might add
protected:
};







#endif

