//text_box.cpp

#include "main.h"


extern FRAME frame;
extern LOGGER err_log;


char apply_shift(char c, bool shift, bool caps);
bool is_letter(char c);
char toggle_case(char c);
bool is_lower(char c);
bool is_upper(char c);


TEXT_BOX::TEXT_BOX()
{
	type = TBT_INPUT;
	x = 0;
	y = 0;
	rows = 1;
	width = TEXT_BOX_MIN_WIDTH;
	font = FF_DEFAULT;
	input[0] = 0;
	input_index = 0;
	row_height = 10;
	cursor_blip = true;
	cursor_timer = 0;
	cursor_pos = 0;
	cursor[0]=' ';
	cursor[1]=0;
	max_input = 1;
	color_font.r = color_font.g = color_font.b = color_font.a = 1;
}
TEXT_BOX::~TEXT_BOX()
{
	if (type==TBT_CONSOLE)
	{
//		dynfree<char>(match_list, MAX_COMMANDS+1,MAX_ARGUMENT_STRING_LENGTH);
	}
}



//This must be set before some of the others
void TEXT_BOX::set_font(int new_font)
{
	font = new_font;
	row_height = frame.display.fonts->get_max_height(font);	//**
	spacing_x = frame.display.fonts->get_spacing_x(font);
	spacing_y = frame.display.fonts->get_spacing_y(font);
	max_input = width / (spacing_x+frame.display.fonts->get_max_width(font));
}

void TEXT_BOX::set_console()											{ type = TBT_CONSOLE; }
void TEXT_BOX::set_width(int new_width)									{ width = new_width; }
void TEXT_BOX::set_type(int new_type)									{ type = new_type; }
void TEXT_BOX::set_color(float r, float g, float b, float a)			{ graphic_box.set_color(r,g,b,a); }
void TEXT_BOX::set_color_background(float r, float g, float b, float a)	{ graphic_box.set_color_background(r,g,b,a); }
void TEXT_BOX::set_color_font(float r, float g, float b, float a)		{ color_font.r=r; color_font.g=g; color_font.b=b; color_font.a=a; }
void TEXT_BOX::set_graphic(int new_tex,int nw)
{
	w = nw;
	graphic_box.set_tex(new_tex,w);
}

//Font must be set before this.
void TEXT_BOX::set_rows(int new_rows)
{
	rows = new_rows;
	f = rows*row_height + (rows-1)*spacing_y;
	graphic_box.set_height(f+w*2);
	graphic_box.set_dims(width,rows*row_height+w*2+(rows-1)*spacing_y);
}
//Width/height must be set before this
void TEXT_BOX::set_pos(int nx, int ny)
{
	x = nx;
	y = ny;
	graphic_box.set_pos(nx,ny);//,width,rows*row_height+w*2+(rows-1)*spacing_y);
}

void TEXT_BOX::set_text(char *text)
{
	int i;
	if (strlen(text)<=TEXT_BOX_MAX_INPUT)
	{
		for (i=0; i<TEXT_BOX_MAX_INPUT; i++)
			if (text[i]==0) break;
		if (i>=TEXT_BOX_MAX_INPUT)
		{
			input_index = 0;
			cursor_pos = 0;
			sprintf(input, "Input is fuxxor3d somehow what did you doooo");
		}
		else
		{
			input_index = i;
			cursor_pos = i;
			sprintf(input,"%s",text);
			update_input_width();
		}
	}
	else
	{
		input_index = 0;
		cursor_pos = 0;
		sprintf(input,"Input too large: %i",strlen(text));
	}
}

void TEXT_BOX::update_input_width()
{
	int i;
	for (i=0; i<input_index; i++)
		input_width[i] = frame.display.fonts->get_width(font,input[i]);
}


int TEXT_BOX::get_pixel_height()		{ return graphic_box.get_height(); }
void TEXT_BOX::read_input(char *into)	{ sprintf(into,"%s",input); }


void TEXT_BOX::draw()
{
	int cursor_offset = -spacing_x;
	if (type!=TBT_READONLY)
	{
		for (int i=0; i<cursor_pos; i++)
			cursor_offset += input_width[i] + spacing_x;

		cursor_timer += frame.engine.get_super_time_factor();
		if (cursor_timer>=CURSOR_BLIP_DELAY)
		{
			cursor_timer = 0;
			if (cursor_blip)
			{
				cursor_blip = false;
				cursor[0] = ' ';
//				input[input_index] = ' ';
//				input[input_index+1] = 0;
			}
			else
			{
				cursor_blip = true;
				cursor[0] = '|';
//				input[input_index] = '|';
//				input[input_index+1] = 0;
			}
		}
	}


	graphic_box.draw();
/*
	frame.magic.try_begin(2);
//	frame.magic.try_end();
//	glColor3f(.8,.2,0);
//	glDisable(GL_TEXTURE_2D);
//	glBegin(GL_POLYGON);
	glVertex3i(x,		y,					10);
	glVertex3i(x,		y+rows*row_height,	10);
	glVertex3i(x+width,	y+rows*row_height,	10);
	glVertex3i(x+width,	y,					10);
//	glEnd();
//	glEnable(GL_TEXTURE_2D);
*/

	frame.magic.try_color(color_font.r,color_font.g,color_font.b);
	frame.display.fonts->draw(font,input,x+w,y-row_height-w);
	frame.display.fonts->draw(font,cursor,x+w+spacing_x+cursor_offset,y-row_height-w);

}

void TEXT_BOX::send_input(char c, bool shift, bool caps)
{
	c = apply_shift(c, shift, caps);
	send_input(c);
}
void TEXT_BOX::send_input(char c)
{
	if (input_index+1>=max_input) return;

	int i;
	err_log << "C: " << c << endl;
	if (c>=32 && c<=126)
	{
		if (input_index>=TEXT_BOX_MAX_INPUT-1) return;

		i = input_index;
		while (cursor_pos<i)
		{
			input[i] = input[i-1];
			input_width[i] = input_width[i-1];
			i--;
		}

		input[cursor_pos] = c;
		input_width[cursor_pos] = frame.display.fonts->get_width(font,c);
		cursor_pos++;

		input[input_index+1] = 0;
		input_index++;


//		sprintf(input,"%s%c",c);
	}
	else
	{
	}

	if (type==TBT_CONSOLE)
	{
		frame.console.match_command(input);
	}
}

void TEXT_BOX::flush()
{
	//flush input, send wherever it's going
	if (input[input_index]=='|') input[input_index] = 0;
	frame.console.submit(input);
	input[0] = 0;
	input_index = 0;
	input_width[0] = 0;
	cursor_pos = 0;
}




char apply_shift(char c, bool shift, bool caps)
{
	if (is_letter(c) && caps)
		c = toggle_case(c);

	if (shift)
	{
		if (is_letter(c))
			c = toggle_case(c);
		else
		{
			switch (c)
			{
			case '`':	c = '~';	break;
			case '1':	c = '!';	break;
			case '2':	c = '@';	break;
			case '3':	c = '#';	break;
			case '4':	c = '$';	break;
			case '5':	c = '%';	break;
			case '6':	c = '^';	break;
			case '7':	c = '&';	break;
			case '8':	c = '*';	break;
			case '9':	c = '(';	break;
			case '0':	c = ')';	break;
			case '-':	c = '_';	break;
			case '=':	c = '+';	break;
			case '[':	c = '{';	break;
			case ']':	c = '}';	break;
			case 92:	c = 124;	break;
			case ';':	c = ':';	break;
			case 39:	c = 34;		break;
			case ',':	c = '<';	break;
			case '.':	c = '>';	break;
			case 47:	c = '?';	break;

			case '~':	c = '`';	break;
			case '!':	c = '1';	break;
			case '@':	c = '2';	break;
			case '#':	c = '3';	break;
			case '$':	c = '4';	break;
			case '%':	c = '5';	break;
			case '^':	c = '6';	break;
			case '&':	c = '7';	break;
			case '*':	c = '8';	break;
			case '(':	c = '9';	break;
			case ')':	c = '0';	break;
			case '_':	c = '-';	break;
			case '+':	c = '=';	break;
			case '{':	c = '[';	break;
			case '}':	c = ']';	break;
			case 124:	c = 92;		break;
			case ':':	c = ';';	break;
			case 34:	c = 39;		break;
			case '<':	c = ',';	break;
			case '>':	c = '.';	break;
			case '?':	c = 47;		break;
			}
		}
	}
	return c;
}

bool is_letter(char c)
{
	return (is_lower(c) || is_upper(c));
}

char toggle_case(char c)
{
	if (is_lower(c))	return (c - 32);
	if (is_upper(c))	return (c + 32);
	return c;
}

bool is_lower(char c)
{
	return (c>=97 && c<=122);
}
bool is_upper(char c)
{
	return (c>=65 && c<=90);
}

void TEXT_BOX::send_left()
{
	if (cursor_pos>0)
		cursor_pos--;
}
void TEXT_BOX::send_right()
{
	if (cursor_pos<input_index)
		cursor_pos++;
}
void TEXT_BOX::send_backspace()
{
	int i;
	if (cursor_pos<=0) return;
	i = cursor_pos;
	while (i<=input_index)
	{
		input[i-1] = input[i];
		input_width[i-1] = input_width[i];
		i++;
	}
	input_index--;
	cursor_pos--;

	if (type==TBT_CONSOLE)
		frame.console.match_command(input);
}
void TEXT_BOX::send_delete()
{
	int i;
	if (cursor_pos>=input_index) return;
	i = cursor_pos;
	while (i<=input_index)
	{
		input[i] = input[i+1];
		input_width[i] = input_width[i+1];
		i++;
	}
	input_index--;

	if (type==TBT_CONSOLE)
		frame.console.match_command(input);
}



void TEXT_BOX::send_up()
{
	if (type==TBT_CONSOLE)
		frame.console.send_up();
}
void TEXT_BOX::send_down()
{
	if (type==TBT_CONSOLE)
		frame.console.send_down();
}




