//text_box.h

#ifndef _TEXT_BOX_
#define _TEXT_BOX_


//Moved in from console.h because I suck at compiling
#define MAX_COMMANDS				128
#define MAX_ARGUMENT_STRING_LENGTH	128


#define TBT_INPUT			1
#define TBT_CONSOLE			2
#define TBT_READONLY		3

#define TEXT_BOX_MAX_INPUT 1024
#define TEXT_BOX_MIN_WIDTH 4

#define CURSOR_BLIP_DELAY	.1f

struct MATCH_LIST
{

};

class TEXT_BOX
{
public:
	TEXT_BOX();
	~TEXT_BOX();

	void draw();
	void send_input(char c);
	void send_input(char c, bool shift, bool caps);

	void set_pos(int nx, int ny);
	void set_font(int new_font);
	void set_console();
	void set_width(int new_width);
	void set_graphic(int new_tex, int nw);
	void set_rows(int new_rows);
	void set_type(int new_type);
	void set_text(char *text);

	void set_color(float r, float g, float b, float a);
	void set_color_background(float r, float g, float b, float a);
	void set_color_font(float r, float g, float b, float a);

	void send_left();
	void send_right();
	void send_backspace();
	void send_delete();
	void send_up();
	void send_down();

	void update_input_width();

	int get_pixel_height();
	void read_input(char *into);

	void flush();

protected:

	bool cursor_blip;
	float cursor_timer;
	int cursor_pos;
	char cursor[2];

	int type;

	int x;
	int y;
	int rows;
	int width;
	int font;
	int row_height;
	int w;
	int f;

	int max_input;

	char input_index;
	char input[TEXT_BOX_MAX_INPUT];
	int input_width[TEXT_BOX_MAX_INPUT];
	int spacing_x;
	int spacing_y;

	GRAPHIC_BOX graphic_box;

	IMG_RGBAf color_font;

};







#endif




