//vectors.h

#include "main.h"

extern FRAME frame;

void cross(double *r, double *a, double *b)
{
	r[0] = a[1]*b[2] - a[2]*b[1];
	r[1] = a[2]*b[0] - a[0]*b[2];
	r[2] = a[0]*b[1] - a[1]*b[0];
}

void normal_face(double *r, double *a, double *b, double *c)
{
	double tmp1[3];
	double tmp2[3];
	subtract(tmp1,a,b);
	subtract(tmp2,b,c);
	cross(r,tmp1,tmp2);
	normalize(r);
}

void subtract(double *r, double *a, double *b)
{
	r[0] = a[0] - b[0];
	r[1] = a[1] - b[1];
	r[2] = a[2] - b[2];
}

void normalize(double *r)
{
	double d;
	d = sqrt( r[0]*r[0] + r[1]*r[1] + r[2]*r[2] );
	normalize(r,d);
}
void normalize(double *r, double d)
{
	if (d==0)
	{
		frame.error("Normalizing vector of length zero, aborting.");
		return;
	}
	r[0] /= d;
	r[1] /= d;
	r[2] /= d;
}

void reverse(double *r)
{
	r[0] *= -1;
	r[1] *= -1;
	r[2] *= -1;
}


double dot(double *v1, double *v2)
{
  double prod;
  prod = v1[0] * v2[0] + v1[1] * v2[1] + v1[2] * v2[2];
  return prod;
}

