//viewport.h


#ifndef _VIEWPORT_
#define _VIEWPORT_


#define PROJECTION_NULL			0
#define PROJECTION_ORTHO		1
#define PROJECTION_PERSPECTIVE	2

class VIEWPORT
{
public:
	VIEWPORT();

	void draw();	//not really drawing, but called the same
	void draw_grid() {grid3D.draw();}

	void set_ul();
	void set_ur();
	void set_ll();
	void set_lr();

	void cycle_poly();
	void cycle_wire();
	void cycle_normal();
	void cycle_points();
	void cycle_hidden();
	void cycle_grid();
	void cycle_lighting();
	void cycle_spawn_box();
	void cycle_visualization();

	void set_camera();

	int get_poly()		{return poly;}
	int get_wire()		{return wire;}
	int get_normal()	{return normal;}
	int get_points()	{return points;}
	int get_hidden()	{return hidden;}
	int get_grid()		{return grid;}
	int get_lighting()	{return lighting;}
	int get_spawn_box()	{return spawn_box;}
	int get_visualization() {return visualization;}

	void zoom_out()		{camera.zoom_out();}
	void zoom_in()		{camera.zoom_in();}
	void grid_up()		{camera.grid_up();}
	void grid_down()	{camera.grid_down();}

	void set_matrices();

	bool will_force_new_list();
	void do_force_new_list();

protected:
	int which_corner;

	int ox, oy;
	int dx, dy;

	int projection;

	int poly;
	int wire;
	int normal;
	int points;
	int hidden;
	int grid;
	int lighting;
	int spawn_box;
	int visualization;

	bool force_new_list;
	GRID grid3D;

	//We will have a camera for each viewport.  FRAME will have a
	// link to the current camera (active camera vs drawing camera)

	CAMERA camera;
};

class VIEWPORTS
{
public:
	VIEWPORTS();

	void init();
	int get_viewport(int x, int y);

	VIEWPORT vp[4];

	int divider_x;
	int divider_y;

	int divider_padding;

};











#endif




